/*
 * Copyright (C) 2003, 2004, 2005 Filip Pizlo. All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY FILIP PIZLO ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL FILIP PIZLO OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
 */

#include "tsf_internal.h"

/* number of spaces per 'tab' */
#define SPACES_PER_TAB 4

/* number of spaces plus one for zero character */
#define SPACES_SIZE 81

static char spaces[SPACES_SIZE];

static void real_init_indent(void) {
    uint32_t i;
    for (i=0;i<SPACES_SIZE-1;++i) {
        spaces[i]=' ';
    }
    spaces[SPACES_SIZE-1]=0;
}

static tsf_once_t once_control = TSF_ONCE_INIT;

static void init_indent(void) {
    tsf_once(&once_control, real_init_indent);
}

const char *tsf_indent_str(uint32_t indent) {
    init_indent();
    if (indent*SPACES_PER_TAB>SPACES_SIZE) {
        indent=SPACES_SIZE/SPACES_PER_TAB;
    }
    
    return spaces+SPACES_SIZE-1-indent*SPACES_PER_TAB;
}

