#!/bin/sh

# Use this build script if you want to compare TSF to Protobuf.

set -e
set -x

CFLAGS="`tsf_config --cppflags --cflags` -Ibuild -I."
LDFLAGS=`tsf_config --ldflags --libs`

mkdir -p build

tsf_define tsf_tuple.t -pthread -odir build

gcc -c -o build/tsf_tuple.o build/tsf_tuple.c $CFLAGS
gcc -c -o build/tsf_tuple_speed.o tsf_tuple_speed.c $CFLAGS
gcc -o build/tsf_tuple_speed build/tsf_tuple.o build/tsf_tuple_speed.o $LDFLAGS

CFLAGS="`tsf_config --cppflags --cflags` -O2 -g -Wall -Ibuild -I/usr/local/include -I."
LDFLAGS="-lprotobuf `tsf_config --ldflags --libs`"

protoc proto_tuple.proto --cpp_out=build
g++ -c -o build/proto_tuple.pb.o build/proto_tuple.pb.cc $CFLAGS
g++ -c -o build/proto_tuple_speed.o proto_tuple_speed.cpp $CFLAGS
g++ -o build/proto_tuple_speed build/proto_tuple.pb.o build/proto_tuple_speed.o $LDFLAGS
